package money.persistence;

import java.io.*;
import java.util.ArrayList;
import java.util.Collection;

import money.model.*;

public class MyMovimentiManager implements MovimentiManager
{
	@SuppressWarnings("unchecked")
	@Override
	public Collection<Movimento> leggiMovimenti(InputStream inputStream) throws IOException, InvalidDataException
	{
		ObjectInputStream ois = new ObjectInputStream(inputStream);
		Collection<Movimento> movimenti = null;
		try
		{
			movimenti = (Collection<Movimento>)ois.readObject();
		}
		catch (EOFException e)
		{
		}
		catch (ClassNotFoundException e)
		{
			throw new InvalidDataException("Dati non validi", e);
		}
		catch (InvalidClassException e)
		{
			throw new InvalidDataException("Dati non validi", e);
		}
		finally
		{
			ois.close();			
		}
		return movimenti != null ? movimenti : new ArrayList<Movimento>();
	}

	@Override
	public void scriviMovimenti(Collection<Movimento> movimenti, OutputStream outputStream) throws IOException, InvalidDataException
	{
		ObjectOutputStream oos = new ObjectOutputStream(outputStream);
		try
		{
			oos.writeObject(movimenti);
		}
		catch (InvalidClassException e)
		{
			throw new InvalidDataException("Scrittura: dati non validi", e);
		}
		finally
		{
			oos.close();
		}
	}
}
